; CONSOLE #
include win64a.inc
includelib msvcrt.lib
 
MAXSCREENX = 80
MAXSCREENY = 25
buffersize = 200
 
.code
WinMain proc
local coord:COORD
local BUFF[buffersize]:byte
local ConsoleWindow:SMALL_RECT
local result:qword
local dwLength:dword
local cci:CONSOLE_CURSOR_INFO
local MOUSE_KEY:INPUT_RECORD
 
        invoke  FreeConsole         ; release the existing console
        invoke  AllocConsole            ; create the console
    	invoke  GetStdHandle,STD_INPUT_HANDLE            ; receive handle for a input
    	mov	hIn,rax
        invoke  GetStdHandle,STD_OUTPUT_HANDLE            ; receive handle for a output
        mov	hOut,rax
    	invoke  GetLargestConsoleWindowSize,eax
;   eax return in 31-16 bits: dwCoord.y
;                 15-00 bits: dwCoord.x
 
        lea r8d,ConsoleWindow       ; lpConsoleWindow
    	and dword ptr [r8+SMALL_RECT],0
;   ConsoleWindow.Left = 0  ConsoleWindow.Top = 0
 
    	sub ax, MAXSCREENX
    	sbb edx, edx
    	and ax, dx
    	add ax, MAXSCREENX-1
    	mov [r8+SMALL_RECT.Right],ax
 
    	shr eax, 16
    	sub eax, MAXSCREENY
    	sbb edx, edx
    	and eax, edx
    	add eax, MAXSCREENY-1
    	mov [r8+SMALL_RECT.Bottom],ax
 
	invoke	SetConsoleWindowInfo,hOut,TRUE            ; bAbsolute
;------------------------------------------------------------------
    	invoke  SetConsoleScreenBufferSize,hOut,MAXSCREENY*10000h+MAXSCREENX  ; establish the new size of console window
    	invoke  SetConsoleTitle,&NameConsole         ; definition of a title bar
;------------------------------------------------------------------------
    	invoke  WriteConsole,hOut,&Str1,sizeof Str1,&BUFF,0            ; display a line of symbols
;hide cursor----------------------------------------
    	invoke  GetConsoleCursorInfo,hOut,&cci
    	lea	edx,cci             ; lpConsoleCursorInfo
    	mov	[rdx+CONSOLE_CURSOR_INFO.bVisible],FALSE
    	invoke  SetConsoleCursorInfo,hOut
;------------------------------------------------------
;demonstration of positioning of the cursor
        mov	coord,10000h    ;y=1 x=0
@@: 	movzx   r9d,coord.y
    	movzx   r8d,coord.x
    	invoke  sprintf,&BUFF,&fmt1
    	mov     dwLength,eax
        invoke  SetConsoleCursorPosition,hOut,coord    ; establish a cursor position
        invoke  WriteConsole,hOut,&BUFF,dwLength,&result,0            ; display a line of symbols
        add	coord,10005h            ; x = x + 5  y = y + 1
    	cmp	coord.y,10
    	jb	@b
; change of color of symbols
    	invoke  SetConsoleCursorPosition,hOut,0C0000h    ; establish a cursor position
    	invoke	SetConsoleTextAttribute,hOut,FOREGROUND_BLUE or BACKGROUND_GREEN     ; set color attributes of the output text
    	invoke  WriteConsole,hOut,&Str3,sizeof Str3,&result,0            ; display a line of symbols
    	invoke  SetConsoleTextAttribute,hOut,FOREGROUND_BLUE or FOREGROUND_GREEN or FOREGROUND_RED     ; set color attributes of the output text
    	invoke  SetConsoleCursorPosition,hOut,0E0000h    ; establish a cursor position
 
    	invoke	WriteConsole,hOut,&Str4,sizeof Str4,&result,0            ; display a line of symbols
; reading the entered line
    	invoke  ReadConsole,hIn,&BUFF,80,&result,0         ; wait for input of a line of symbols
    	mov	rax,result
    	lea	esi,BUFF
    	mov	byte ptr [rax+rsi-2],0      ; 2 symbols CR and LF
; remove ASCII code of the entered symbols
    	xor	eax,eax
    	mov	dwLength,eax
@@: 	lodsb
    	or	eax,eax
    	jz	@f
    	invoke  printf,&fmt2,eax
    	add	dwLength,eax
    	jmp	@b
@@: 	mov	r8d,dwLength
    	neg	r8                  ; length of the removed line
    	invoke  WriteConsole,hOut,&BUFF,,&result,0
; it is possible to use the functions printf, gets, etc.
    	invoke  printf,&Str5
    	invoke  gets,&BUFF
    	invoke  printf,&fmt3,&BUFF
    	invoke  printf,&Str2
@@:     invoke  ReadConsoleInput,hIn,&MOUSE_KEY,1,&result
        lea     eax,MOUSE_KEY
    	cmp     [rax+INPUT_RECORD.EventType],MOUSE_EVENT
    	je	@b
    	cmp     [rax+INPUT_RECORD.EventType],KEY_EVENT
    	jne     @b
    	cmp     [rax+INPUT_RECORD.KeyEvent.wVirtualKeyCode],VK_ESCAPE
    	jne     @b
        invoke  FreeConsole; 
    	invoke	RtlExitUserProcess,NULL
WinMain endp
hOut	dq ?
hIn	dq ?
NameConsole db 'Simple example of console',0
Str1    db 'This is sample output string',13,10
Str2    db 'For exit from program press ESC or CTRL+C or CTRL+Break',0
Str3    db 'This is Blue text on Green background'
Str4    db 'Enter a line of symbols and you can to see ASCII-code of symbols: ',0Dh,0Ah
Str5    db 0Dh,0Ah,'This is a test. Enter another string: ',0Dh,0Ah,0
fmt1    db "Text position X=%d, Y=%d",0
fmt2    db "%X ",0
fmt3    db "%s",0Dh,0Ah,0
end